library arasu.model;
import "dart:mirrors";
import "dart:convert";

abstract class Model {
  Map<String,dynamic> attributes;
  
  Map<String,dynamic> get changes {
    Map<String,dynamic> attrs = encode();
    Map<String,dynamic> changed = new Map<String,dynamic>();
    attrs.keys.forEach((e){ if(attrs[e] != attributes[e]) changed[e]= attrs[e];});
    return changed;
  }  

  Map encode(){
    Map map = new Map();
    InstanceMirror im = reflect(this);
    declarations(im.type).forEach((dm) {
      var key = MirrorSystem.getName(dm.simpleName);
      var val = im.getField(dm.simpleName).reflectee;
      if(val.runtimeType!=Null) map[key] = val.toString();
    });
    return map;
  }
  
  String encodeWithAttr({String key: 'attr'}) => JSON.encode({key:encode()});
  Iterable<DeclarationMirror> declarations(ClassMirror cm) => 
      cm.declarations.values.where((dm) => 
          dm is VariableMirror && 
          !dm.isConst && 
          !dm.isFinal && 
          !dm.isPrivate && 
          !dm.isStatic && 
          !dm.isTopLevel);
}